
Event::Attach( eventConnected, Demo::onConnected );
Event::Attach( eventLeaveServer, Demo::onLeaveServer );

$Demo::Count = -1;
$Demo::Scale[$Demo::Count++] = 0.000000000;
$Demo::Scale[$Demo::Count++] = 0.00390625;
$Demo::Scale[$Demo::Count++] = 0.0078125;
$Demo::Scale[$Demo::Count++] = 0.015625;
$Demo::Scale[$Demo::Count++] = 0.03125;
$Demo::Scale[$Demo::Count++] = 0.0625;
$Demo::Scale[$Demo::Count++] = 0.125;
$Demo::Scale[$Demo::Count++] = 0.25;
$Demo::Scale[$Demo::Count++] = 0.5;
$Demo::Scale[$Demo::Count++] = 1;
$Demo::NormalSpeed = $Demo::Count;
$Demo::Scale[$Demo::Count++] = 2;
$Demo::Scale[$Demo::Count++] = 3;
$Demo::Scale[$Demo::Count++] = 4;
$Demo::Scale[$Demo::Count++] = 5;
$Demo::Scale[$Demo::Count++] = 6;
$Demo::Scale[$Demo::Count++] = 8;
$Demo::Scale[$Demo::Count++] = 10;
$Demo::Scale[$Demo::Count++] = 12;
$Demo::Scale[$Demo::Count++] = 14;
$Demo::Scale[$Demo::Count++] = 16;
$Demo::Scale[$Demo::Count++] = 20;
$Demo::Scale[$Demo::Count++] = 24;
$Demo::Scale[$Demo::Count++] = 28;
$Demo::Scale[$Demo::Count++] = 32;
$Demo::Scale[$Demo::Count++] = 36;

function Demo::onConnected() {
	if ( !$playingDemo )
		return;
	
	Demo::SpeedControl( "normal" );
	pushActionMap( "demoMap.sae" );
}

function Demo::onLeaveServer() {
	if ( !$playingDemo )
		return;
	
	Demo::SpeedControl( "normal" );
	popActionMap( "demoMap.sae" );
}


function Demo::SpeedControl( %fn ) {
	if ( !$playingDemo )
		return;

	switch ( %fn ) {
		case "pause": $Demo::CurrentScale = 0; break;
		case "sd": $Demo::CurrentScale--; break;
		case "ff": $Demo::CurrentScale++; break;
		case "normal":
		default: $Demo::CurrentScale = $Demo::NormalSpeed; break;
	}

	$Demo::CurrentScale = clamp( $Demo::CurrentScale, 0, $Demo::Count );
	$SimGame::TimeScale = $Demo::Scale[ $Demo::CurrentScale ];
}

function DemoDrop::Start()
{
	if ($PlayingDemo)
		return;
	Schedule::Add("DemoDrop::SetupDemo();", 1);
}

function DemoDrop::SetupDemo(%address)
{
	if ($PlayingDemo)
		return;

	$ConnectedToServer = FALSE;

	setCursor(MainWindow, "Cur_Arrow.bmp");

	disconnect();
	Event::Trigger(eventDisconnected);

	deleteObject(ConsoleScheduler);
	newObject(ConsoleScheduler, SimConsoleScheduler);

	cursorOn(MainWindow);

	$recordDemo = true;

	setupRecorderFile();
	myConnect($Server::Address, $Server::JoinPassword);
}

$AutoName::Recording = "";
$AutoName::AutoDemo = true;
function setupRecorderFile()
{
	%str = timestamp();
	%year = string::getsubstr(%str, 0, 4);
	%month = string::getsubstr(%str, 5, 2);
	%day = string::getsubstr(%str, 8, 2);
	%hour = string::getsubstr(%str, 11, 2);
	%minutes = string::getsubstr(%str, 14, 2);
	%seconds = string::getsubstr(%str, 17, 2);

	//returns time in global $time
	$f = AutoName::StripString(%month@"-"@%day@"-"@%year@"__"@%hour@"."@%minutes@" - "@$PCFG::Name);
	$recorderFileName = "recordings\\" @ $f @ ".rec";

	//autoname stuff
	$AutoName::Stub = $f;
	$AutoName::Dummy = $recorderFileName;
	$AutoName::Recording = true;
	$AutoName::Maps = 0;
	
	echo("********** Recording to - " @ $recorderFileName);
}

function AutoName::Stop()
{
	if (!$AutoName::Recording || $PlayingDemo || $AutoName::Maps==0)
		return;

	%str = "";
	//build a list of the maps we played
	for (%i = 0; %i< $AutoName::Maps; %i++)
	{
		%m = $AutoName::MapList[%i];
		%map = $AutoName::Lookup[ %m ];
		
		if (%map == "")
		{
			//see if its an lt map
			%lttest = String::GetSubStr(%m, 0, String::Length(%m)-2);
			%map = $AutoName::Lookup[%lttest];
			if ( %map != "" )
				%map = %map @ "LT";
			else
				%map = %m;
		}
		
		%str = %str @ " - " @ %map;
	}
	
	%dst = "Recordings\\" @ $AutoName::Stub @ %str @ ".rec";
	echo ("k/os: Trying to Copy... " @ $AutoName::Dummy @ " to " @ %dst);
	
	//try to copy the original demo to our new name
	if (File::copy($AutoName::Dummy, %dst))
	{
		echo("k/os: Deleting old recording");
		//delete the old
		File::delete($AutoName::Dummy);
	}

	if ($AutoName::AutoDemo)
		setupRecorderFile();
}

//add new map played
function AutoName::onMissionInfo(%server, %missionName, %ServerMissionType)
{
	if (!$AutoName::Recording)
		return;

	$AutoName::MapList[$AutoName::Maps++ - 1] = String::ToLower( String::Replace(%missionName, "_", "") );
}

//utility shit
function AutoName::StripString(%str)
{
	%str = string::replace(%str, "[",  "_");
	%str = string::replace(%str, "]",  "_");
	%str = string::replace(%str, "<",  "_");
	%str = string::replace(%str, ">",  "_");
	%str = string::replace(%str, "?",  "_");
	%str = string::replace(%str, ":",  "_");
	%str = string::replace(%str, "*",  "_");
	%str = string::replace(%str, "/",  "_");
	%str = string::replace(%str, "\\", "_");
	%str = string::replace(%str, "|",  "_");
	
	return %str;
}

function myConnect(%serverIp, %serverPw)
{
	$Server::Address = %serverIp;
	$Server::JoinPassword = %serverPw;
	connect(%serverIp);
}


//map abbreviations to shorten filenames
$AutoName::Lookup["acrophobia"] = "Acrophobia";
$AutoName::Lookup["arcticwolf"] = "ArcticWolf";
$AutoName::Lookup["Avalanche"] = "Avalanche";
$AutoName::Lookup["bastardforge"] = "BastardForge";
$AutoName::Lookup["bastardforgeday"] = "BastardForgeDay";
$AutoName::Lookup["broadside"] = "Broadside";
$AutoName::Lookup["canyoncrusadedeluxe"] = "CanyonCrusadeDeluxe";
$AutoName::Lookup["canyoncrusade"] = "CanyonCrusade";
$AutoName::Lookup["cloakofnight"] = "CloakofNight";
$AutoName::Lookup["dangerouscrossing"] = "DangerousCrossing";
$AutoName::Lookup["desertofdeath"] = "DesertofDeath";
$AutoName::Lookup["dayfall"] = "Dayfall";
$AutoName::Lookup["domino"] = "Domino";
$AutoName::Lookup["emeraldvalley"] = "EmeraldValley";
$AutoName::Lookup["hildebrand"] = "Hildebrand";
$AutoName::Lookup["icedagger"] = "Icedagger";
$AutoName::Lookup["iceridge"] = "Iceridge";
$AutoName::Lookup["integration"] = "Integration";
$AutoName::Lookup["jaggedclaw"] = "Jaggedclaw";
$AutoName::Lookup["midnightmayhem"] = "MidnightMayhem";
$AutoName::Lookup["midnightmayhemdeluxe"] = "MidnightMayhemDeluxe";
$AutoName::Lookup["northernlights"] = "NorthernLights";
$AutoName::Lookup["obfuscation"] = "Obfuscation";
$AutoName::Lookup["raindance"] = "Raindance";
$AutoName::Lookup["reliquary"] = "Reliquary";
$AutoName::Lookup["rollercoaster"] = "Rollercoaster";
$AutoName::Lookup["runout"] = "Runout";
$AutoName::Lookup["scarabrae"] = "Scarabrae";
$AutoName::Lookup["sidewinder"] = "Sidewinder";
$AutoName::Lookup["simoom"] = "Simoom";
$AutoName::Lookup["lotus"] = "Lotus";
$AutoName::Lookup["snowblind"] = "Snowblind";
$AutoName::Lookup["spincycle"] = "Spincycle";
$AutoName::Lookup["starfall"] = "Starfall";
$AutoName::Lookup["stonehenge"] = "Stonehenge";
$AutoName::Lookup["stonehengepub"] = "StonehengePUB";
$AutoName::Lookup["stonehengecluster"] = "StonehengePUBc";
$AutoName::Lookup["tesseract"] = "Tesseract";
$AutoName::Lookup["timberline"] = "Timberline";
$AutoName::Lookup["opensnare"] = "Opensnare";
$AutoName::Lookup["firenza"] = "Firenza";
$AutoName::Lookup["teamside"] = "Teamside";
$AutoName::Lookup["anthill"] = "Anthill";
$AutoName::Lookup["fogofwar"] = "FogofWar";
$AutoName::Lookup["citadels"] = "Citadels";
$AutoName::Lookup["adishbestservedcold"] = "ADishBestServedCold";
$AutoName::Lookup["hammerdown"] = "HammerDown";
$AutoName::Lookup["bloodyvengeance"] = "BloodyVengeance";
$AutoName::Lookup["siege"] = "Siege";


//patch a few things in to always record (covers almost every situation
if ($AutoName::AutoDemo)
{
	//record demo when clicking join button
	Event::Attach(eventJoinGame, setupRecorderfile);
	//demo drop on map change
	Event::Attach(eventChangeMission, DemoDrop::Start);

	function PlayerSetupNext()
	{
		if ($QuickStart == "TRUE")
			QuickStart();
		else
		{
			if ($PCFG::Name == "")
				OpenNewPlayerDialog();
			else
			GuiLoadContentCtrl(MainWindow, "gui\\Connect.gui");
		}
		
		setupRecorderFile();
	}

	setupRecorderFile();
	$recordDemo=true;
}

Event::Attach(eventMissionInfo, AutoName::onMissionInfo);

//make sure we stop/rename in every possible situation
Event::Attach(eventDisconnected, AutoName::Stop);
Event::Attach(eventConnectionLost, AutoName::Stop);
Event::Attach(eventConnectionTimeout, AutoName::Stop);
Event::Attach(eventExit, AutoName::Stop);